// *************************************************************************
//
// Copyright (C) 2004,2005 Bruno PAGES  All rights reserved.
//
// This file is part of the BOUML Uml Toolkit.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
// e-mail : bouml@free.fr
// home   : http://bouml.free.fr
//
// *************************************************************************

#include <qtextstream.h> 

#include "UmlItem.h"

UmlItem::~UmlItem() {
}

void UmlItem::generate_comment(const char *& p, QTextOStream & f_h,
			       const QCString & indent) {
  p += 10;
  
  const char * comment = description();
  
  if ((comment != 0) && (*comment != 0)) {
    f_h << "//";

    do {
      f_h << *comment;
      if ((*comment++ == '\n') && *comment)
	f_h << indent << "//";
    } while (*comment);
    
    switch (*p) {
    case 0:
    case '\n':
      break;
    case '#':
      f_h << '\n';
      break;
    default:
      f_h << '\n' << indent;
    }
  }
}

void UmlItem::generate() {
  // does nothing
}

UmlPackage * UmlItem::package() {
  return parent()->package();
}
