// *************************************************************************
//
// Copyright (C) 2004,2005 Bruno PAGES  All rights reserved.
//
// This file is part of the BOUML Uml Toolkit.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
// e-mail : bouml@free.fr
// home   : http://bouml.free.fr
//
// *************************************************************************

#include <qtextstream.h> 

#include "UmlItem.h"

UmlItem::~UmlItem() {
}

void UmlItem::generate_comment(const char *& p, QTextOStream & f,
			       const QCString & indent) {
  p += 10;
  
  const char * comment = description();
  
  if ((comment != 0) && (*comment != 0)) {
    const char * pnl = strchr(comment, '\n');
    
    if ((pnl != 0) && (pnl[1] != 0)) {
      // several lines , use /* */
      f << "/**";
      
      do {
	if (*comment == '\n') {
	  if (comment[1] == 0)
	    break;
	  f << '\n' << indent << " * ";
	}
	else
	  f << *comment;
      } while (*++comment);
      
      f <<'\n' << indent << " */";
    }
    else
      // only one line
      f << "//" << comment;
      
    switch (*p) {
    case 0:
    case '\n':
      break;
    default:
      f << '\n' << indent;
    }
  }
}

void UmlItem::generate() {
  // does nothing
}

UmlPackage * UmlItem::package() {
  return parent()->package();
}
